<script lang="ts">
  import { createEventDispatcher } from "svelte";
  import Card from "./Card.svelte";
  import Clickable from "./Clickable.svelte";

  const dispatch = createEventDispatcher();

  export let cards: CardId[];
  export let growUpwards: boolean = false;
  export let clickable: boolean = false;
</script>

<div class="relative">
  {#each cards as card, idx (card)}
    {@const offset = growUpwards ? -idx : idx}

    <div class="card" style:--card-offset-y="{offset * 1.75}em">
      <Card {card} />
    </div>
  {/each}
  {#if clickable}
    <div
      class="place-card"
      style:--button-offset-y="{Math.max(0, cards.length - 1) * 1.75}em"
    >
      <Clickable on:click={() => dispatch("place_card")} />
    </div>
  {/if}
</div>

<style>
  .card:not(:first-child) {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%) translateY(var(--card-offset-y));
  }

  .place-card {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%) translateY(var(--button-offset-y));
  }
</style>
